#include"led.h"
#include"LCD.h"
#include"delay.h"

extern u16  Conce_PM1_0;       // PM1.0Ũ
extern u16  Conce_PM2_5;       // PM2.5Ũ
extern u16  Conce_PM10;        // PM10Ũ

u16 IAQI[8]={0,50,100,150,200,300,400,500};
u16 PM10[8]={0,50,150,250,350,420,500,600};
u16 PM25[8]={0,35,75,115,150,250,350,500};

u16 IAQIPM10;	//PM10ָ
u16 IAQIPM25;	//PM2.5ָ
u16 CpPM10;		//PM10Ũ
u16 CpPM25;		//PM2.5Ũ
u16 BpHi;			//CpȾŨֵĸֵ
u16 BpLo;			//CpȾŨֵĵֵ
u16 IAQIHi;		//BpHiӦĿָ
u16 IAQILo;		//BpLoӦĿָ
u16 AQI;			//ָ
u8  Max=10;		//Max=0ҪȾΪPM25Max=1ΪPM10Max=2˫Ⱦ

void delay_BUSY(void) 	 // ʾ ʱ 
{ 
		u16 a;
		for (a=0; a<100; a++) ;
		while(HMI_BUSY);		   // ֮󣬵ȴBUSYΪ0

}

void Window(void)
{
		printf("CLS(0);");
		printf("DS48(10,12,'ɽ',7,0);");
		printf("DS32(110,28,'ʵʱָ(AQI)',7,0);");
		printf("CIR(92,160,56,4);");
		printf("CIR(92,160,55,4);");
		printf("DS24(55,198,'AQIָ',4,0);");
		printf("CIR(239,160,55,4);");
		printf("CIR(239,160,56,4);");
		printf("DS24(180,198,'ҪȾ',4,0);");
		printf("CIR(386,160,55,4);");
		printf("CIR(386,160,56,4);");
		printf("DS24(340,198,'PM2.5Ũ',4,0);");
		printf("BOXF(50,265,100,280,2);");		//ɫ
		printf("BOXF(100,265,150,280,4);");		//ɫ
		printf("SCC(37,64480);");
		printf("BOXF(150,265,200,280,37);");	//ɫ
		printf("BOXF(200,265,250,280,1);");	//ɫ
		printf("SCC(19,38921);");
		printf("BOXF(250,265,300,280,19);");	//ɫ
		printf("SCC(18,30724);");
		printf("BOXF(300,265,350,280,18);");	//ֺɫ
		printf("DS16(48,285,'0',7,0);");
		printf("DS16(91,285,'50',7,0);");
		printf("DS16(140,285,'100',7);");
		printf("DS16(190,285,'150',7);");
		printf("DS16(240,285,'200',7);");
		printf("DS16(290,285,'300',7);");
		printf("DS16(340,285,'500',7);");
		printf("DS16(369,178,'ug/m3',7,0);");
		printf("CBOX(0,0,479,318,5,4);");
		printf("PL(0,76,479,76,4);");
		printf("DS16(400,265,'13:20:36',7);");
		printf("DS16(395,285,'2016-5-18',7,0);");
		printf("\r\n");

//		delay_BUSY();   	     //֮󣬵ȴBUSYΪ0
}


void AQI_Count(void)				//AQIָжҪȾ
{
		u8 i=0;
		u8 j=0;

	
		CpPM10=Conce_PM10;
		

		
		for(i=0;i<7;i++)
		{
				if((CpPM10>PM10[i])&&(CpPM10<PM10[i+1]))
				{
						BpHi=PM10[i+1];
						BpLo=PM10[i];
						IAQIHi=IAQI[i+1];
						IAQILo=IAQI[i];
						IAQIPM10=(IAQIHi-IAQILo)*(CpPM10-BpLo)/(BpHi-BpLo)+IAQILo;
				}
				else if(CpPM10==PM10[i])
				{
						IAQIPM10=IAQI[i];
				}
				else if(CpPM10>=600)
				{
						IAQIPM10=((50/6)*(CpPM10-600))/10+500;	 //
				}
		}

		CpPM25=Conce_PM2_5;
				
		for(j=0;j<7;j++)
		{
				if((CpPM25>PM25[j])&&(CpPM25<PM25[j+1]))
				{
						BpHi=PM25[j+1];
						BpLo=PM25[j];
						IAQIHi=IAQI[j+1];
						IAQILo=IAQI[j];
						IAQIPM25=(IAQIHi-IAQILo)*(CpPM25-BpLo)/(BpHi-BpLo)+IAQILo;
				}
				else if(CpPM25==PM25[j])
				{
						IAQIPM25=IAQI[j];
				}
				else if(CpPM25>=500)
				{
						IAQIPM25=CpPM25;	 //
				}
		}
		
		if(IAQIPM10>IAQIPM25)
		{
				AQI=IAQIPM10;
				Max=1;
		}
		else if(IAQIPM10<IAQIPM25)
		{
				AQI=IAQIPM25;
				Max=0;
		}else if(IAQIPM10==IAQIPM25)
		{
				AQI=IAQIPM10;
				Max=2;
		}
}

void Display(void)
{
//			printf("CLS(0);\r\n");		  	//
//      printf("PIC(0,0,1);");		//ͼ

	
//      printf("SBC(2);");				//ñɫ
//      printf("TPN(2);");				//ģʽ
//      printf("BTN(6,396,278,475,315,0);");	//ȵť
//      printf("BTN(7,0,0,479,274,0);\r\n");

	
				printf("DS48(350,132,'%4d ',7);",Conce_PM2_5);      // PM2.5
//			printf("PS64(0,10,100,'PM1.0:%5d',2);\r\n",Conce_PM1_0);      // PM1.0
//				printf("DS48(0,10,240,'PM10 :%5d',3);\r\n",Conce_PM10);      // PM10 
//			delay_BUSY();   	     //֮󣬵ȴBUSYΪ0
//				printf("DS48(0,0,'PM2.5:%4d  ',1);",Conce_PM2_5);      // PM2.5
//				printf("DS48(0,60,'PM10 :%4d  ',2);",Conce_PM10);      // PM10 
				printf("DS48(55,135,'%4d ',3;",AQI);      // AQI
//					printf("DS48(0,240,'IAQIPM10:%4d  ',5;",IAQIPM10);      // PM2.5
				if(Max==0)
				{
						printf("DS32(203,145,'PM2.5',14);");      // PM2.5 				
				}
				else if(Max==1)
				{
						printf("DS32(203,145,' PM10',14);");      // PM10 				
				}else if(Max==2)
				{
//						printf("DS32(203,135,'PM2.5',14)");
//						printf("DS32(203,160,' PM10',14)");
				}
			
				if(AQI<=50)
				{
						printf("DS24(60,235,'                                                        ',5)");
				}
				else if((AQI>50)&&(AQI<=100))
				{
						printf("DS24(60,235,'                                                        ',5)");
				}
				else if((AQI>100)&&(AQI<=150))
				{
						printf("DS24(60,235,'                                                      ',5)");				
				}
				else if((AQI>150)&&(AQI<=200))
				{
						printf("DS24(60,235,'                            ж                          ',5)");						
				}
				else if((AQI>200)&&(AQI<=300))
				{
						printf("DS24(60,235,'                                      ض                 ',5)");				
				}
				else
				{  
						printf("DS24(60,235,'                                                         ',5)");				
				}

				printf("\r\n");
	//								delay_ms(1000);
				delay_BUSY();
}
